<?php

//////////
///
///   log_fileopen.inc.php
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

if($al & AL_SERV) {
   $dm['log_fileopen.add']                 ['function'] = 'log_fileopen_add';
//   $dm['log_fileopen.add']                ['signature'] = array(array($xmlrpcBoolean,     // return value
//                                                                      $xmlrpcString,      // $backdoor
//                                                                      $xmlrpcString,      // $remoteip
//                                                                      $xmlrpcString,      // $remotehost
//                                                                      $xmlrpcString,      // $remoteuser
//                                                                      $xmlrpcArray));     // $logarray
}

if($al & AL_VIEW) {
   $dm['log_fileopen.getparam']            ['function'] = 'log_fileopen_getparam';
//   $dm['log_fileopen.getparam']           ['signature'] = array(array($xmlrpcStruct,      // return value
//                                                                      $xmlrpcArray,       // $selarray
//                                                                      $xmlrpcArray,       // $backdoorarray
//                                                                      $xmlrpcArray,       // $remoteiparray
//                                                                      $xmlrpcArray,       // $remotehostarray
//                                                                      $xmlrpcArray,       // $remoteuserarray
//                                                                      $xmlrpcArray,       // $tagarray
//                                                                      $xmlrpcArray,       // $acquiredarray
//                                                                      $xmlrpcString));    // $searchstring
}

if($al & AL_VIEW) {
   $dm['log_fileopen.getgeneral']          ['function'] = 'log_fileopen_getgeneral';
//   $dm['log_fileopen.getgeneral']         ['signature'] = array(array($xmlrpcArray,       // return value
//                                                                      $xmlrpcArray,       // $selarray
//                                                                      $xmlrpcArray,       // $backdoorarray
//                                                                      $xmlrpcArray,       // $remoteiparray
//                                                                      $xmlrpcArray,       // $remotehostarray
//                                                                      $xmlrpcArray,       // $remoteuserarray
//                                                                      $xmlrpcArray,       // $tagarray
//                                                                      $xmlrpcArray,       // $acquiredarray
//                                                                      $xmlrpcString,      // $searchstring
//                                                                      $xmlrpcArray,       // $processarray
//                                                                      $xmlrpcBoolean));   // $filenamecheck
}

if($al & AL_VIEW) {
   $dm['log_fileopen.getdetail']           ['function'] = 'log_fileopen_getdetail';
//   $dm['log_fileopen.getdetail']          ['signature'] = array(array($xmlrpcArray,       // return value
//                                                                      $xmlrpcArray,       // $selarray
//                                                                      $xmlrpcArray,       // $backdoorarray
//                                                                      $xmlrpcArray,       // $remoteiparray
//                                                                      $xmlrpcArray,       // $remotehostarray
//                                                                      $xmlrpcArray,       // $remoteuserarray
//                                                                      $xmlrpcArray,       // $tagarray
//                                                                      $xmlrpcArray,       // $acquiredarray
//                                                                      $xmlrpcString,      // $searchstring
//                                                                      $xmlrpcArray,       // $processarray
//                                                                      $xmlrpcArray,       // $filenamearray
//                                                                      $xmlrpcInt));       // $limit
}

if($al & AL_VIEW) {
   $dm['log_fileopen.setgrouppriority']    ['function'] = 'log_fileopen_setgrouppriority';
//   $dm['log_fileopen.setgrouppriority']   ['signature'] = array(array($xmlrpcBoolean,     // return value
//                                                                      $xmlrpcArray,       // $selarray
//                                                                      $xmlrpcArray,       // $linearray
//                                                                      $xmlrpcInt));       // $priority
}



/***************\
*   FUNCTIONS   *
\***************/

function log_fileopen_add($backdoor, $remoteip, $remotehost, $remoteuser, $logarray)
{
   // varchar1  <= process
   // varchar2  <= filename
   // varchar3  <= -
   // int1      <= sizehigh
   // int2      <= sizelow
   // int3      <= flags
   // longtext1 <= -
   // longblob1 <= -

   $ret = db_escape(array(&$backdoor,
                          &$remoteip,
                          &$remotehost,
                          &$remoteuser,
                          &$logarray));

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT `backdoor_id` ";
   $sql .= "FROM `backdoor` ";
   $sql .= "WHERE `backdoor` = '$backdoor'";

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_config']['invbackdoor'];
   }

   $backdoor_id = $ret[0]->backdoor_id;

   foreach($logarray as $log) {
      $sql  = "INSERT INTO `log` (`backdoor_id`, ";
      $sql .=                    "`type`, ";
      $sql .=                    "`remoteip`, ";
      $sql .=                    "`remotehost`, ";
      $sql .=                    "`remoteuser`, ";
      $sql .=                    "`received`, ";
      $sql .=                    "`acquired`, ";
      $sql .=                    "`varchar1`, ";
      $sql .=                    "`varchar2`, ";
      $sql .=                    "`int1`, ";
      $sql .=                    "`int2`, ";
      $sql .=                    "`int3`) ";
      $sql .= "VALUES ('$backdoor_id', ";
      $sql .=         "'FILEOPEN', ";
      $sql .=         "'$remoteip', ";
      $sql .=         "'$remotehost', ";
      $sql .=         "'$remoteuser', ";
      $sql .=         "UTC_TIMESTAMP(), ";
      $sql .=         "'".str_replace(':', '', $log['acquired']->scalar)."', ";
      $sql .=         "'".$log['process']."', ";
      $sql .=         "'".$log['filename']."', ";
      $sql .=         "'".$log['sizehigh']."', ";
      $sql .=         "'".$log['sizelow']."', ";
      $sql .=         "'".$log['flags']."')";

      $ret = db_query($sql);

      if(is_object($ret)) {
         return $ret;
      }
   }

   return true;
}

function log_fileopen_getparam($selarray, $backdoorarray, $remoteiparray, $remotehostarray, $remoteuserarray, $tagarray, $acquiredarray, $searchstring)
{
   $ret = db_escape(array(&$selarray,
                          &$backdoorarray,
                          &$remoteiparray,
                          &$remotehostarray,
                          &$remoteuserarray,
                          &$tagarray,
                          &$acquiredarray,
                          &$searchstring));

   if(is_object($ret)) {
      return $ret;
   }

   $ret = prunebackdoor($selarray);

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT DISTINCT `varchar1` AS `process` ";
   $sql .= "FROM `log` ";
   $sql .= "LEFT JOIN `backdoor` USING (`backdoor_id`) ";
   $sql .= "WHERE (`backdoor` IN ('".implode("', '", $selarray)."')) AND ";
   $sql .=       "(`log_id` <= '".$_SESSION['authmaxlog']."') AND ";
   $sql .=       "(`type` = 'FILEOPEN')";
   foreach(array('backdoorarray', 'remoteiparray', 'remotehostarray', 'remoteuserarray', 'tagarray') as $field) {
      $sql .= (count($$field) ? " AND (`".str_replace('array', '', $field)."` IN ('".implode("', '", $$field)."'))" : '');
   }
   if(count($acquiredarray)) {
      $sql .= " AND (0";
      foreach($acquiredarray as $acquired) {
         $sql .= " OR (`acquired` BETWEEN '".str_replace(':', '', $acquired['begin']->scalar)."' AND '".str_replace(':', '', $acquired['end']->scalar)."')";
      }
      $sql .= ")";
   }
   if($searchstring) {
      $sql .= " AND (0";
      foreach(array('varchar1', 'varchar2') as $field) {
         $sql .= " OR (`$field` REGEXP '$searchstring')";
      }
      $sql .= ")";
   }

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_log']['empty'];
   }

   foreach(array('process') as $field) {
      $tmp->$field = array();
      foreach($ret as $r) {
         array_push($tmp->$field, $r->$field);
      }
      $tmp->$field = array_unique($tmp->$field);
      sort($tmp->$field);
   }

   $ret = $tmp;

   return $ret;
}

function log_fileopen_getgeneral($selarray, $backdoorarray, $remoteiparray, $remotehostarray, $remoteuserarray, $tagarray, $acquiredarray, $searchstring, $processarray, $filenamecheck)
{
   $ret = db_escape(array(&$selarray,
                          &$backdoorarray,
                          &$remoteiparray,
                          &$remotehostarray,
                          &$remoteuserarray,
                          &$tagarray,
                          &$acquiredarray,
                          &$searchstring,
                          &$processarray,
                          &$filenamecheck));

   if(is_object($ret)) {
      return $ret;
   }

   $ret = prunebackdoor($selarray);

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT COUNT(`log_id`) AS `count`, ";
   $sql .=        "DATE_FORMAT(MIN(`acquired`), '%Y%m%dT%T') AS `begin`, ";
   $sql .=        "DATE_FORMAT(MAX(`acquired`), '%Y%m%dT%T') AS `end`, ";
   foreach(array('backdoorarray', 'remoteiparray', 'remotehostarray', 'remoteuserarray') as $field) {
      $sql .= (count($$field) ? "`".str_replace('array', '', $field)."`, " : '');
   }
   $sql .= (count($processarray) ? "`varchar1` AS `process`, " : '');
   $sql .= ($filenamecheck ? "`varchar2` AS `filename`, " : '');
   $sql .= ($filenamecheck ? '' : "COUNT(DISTINCT `varchar2`) AS `filenamecount`, ");
   $sql .=        "MAX(`tag`) AS `priority` ";
   $sql .= "FROM `log` ";
   $sql .= "LEFT JOIN `backdoor` USING (`backdoor_id`) ";
   $sql .= "WHERE (`backdoor` IN ('".implode("', '", $selarray)."')) AND ";
   $sql .=       "(`log_id` <= '".$_SESSION['authmaxlog']."') AND ";
   $sql .=       "(`type` = 'FILEOPEN') ";
   foreach(array('backdoorarray', 'remoteiparray', 'remotehostarray', 'remoteuserarray', 'tagarray') as $field) {
      $sql .= (count($$field) ? "AND (`".str_replace('array', '', $field)."` IN ('".implode("', '", $$field)."')) " : '');
   }
   if(count($acquiredarray)) {
      $sql .= "AND (0";
      foreach($acquiredarray as $acquired) {
         $sql .= " OR (`acquired` BETWEEN '".str_replace(':', '', $acquired['begin']->scalar)."' AND '".str_replace(':', '', $acquired['end']->scalar)."')";
      }
      $sql .= ") ";
   }
   if($searchstring) {
      $sql .= "AND (0";
      foreach(array('varchar1', 'varchar2') as $field) {
         $sql .= " OR (`$field` REGEXP '$searchstring')";
      }
      $sql .= ") ";
   }
   $sql .= (count($processarray) ? "AND (`varchar1` IN ('".implode("', '", $processarray)."')) " : '');
   $sql .= "GROUP BY `type`";
   foreach(array('backdoorarray', 'remoteiparray', 'remotehostarray', 'remoteuserarray', 'tagarray') as $field) {
      $sql .= (count($$field) ? ", `".str_replace('array', '', $field)."`" : '');
   }
   $sql .= (count($processarray) ? ", `varchar1`" : '');
   $sql .= ($filenamecheck ? ", `varchar2`" : '');

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_log']['empty'];
   }

   foreach($ret as &$r) {
      settype($r->count, 'integer');
      xmlrpc_set_type($r->begin, 'datetime');
      xmlrpc_set_type($r->end, 'datetime');
      if(isset($r->filenamecount)) {
         settype($r->filenamecount, 'integer');
      }
      settype($r->priority, 'integer');
   }
   unset($r);

   return $ret;
}

function log_fileopen_getdetail($selarray, $backdoorarray, $remoteiparray, $remotehostarray, $remoteuserarray, $tagarray, $acquiredarray, $searchstring, $processarray, $filenamearray, $limit = -1)
{
   $ret = db_escape(array(&$selarray,
                          &$backdoorarray,
                          &$remoteiparray,
                          &$remotehostarray,
                          &$remoteuserarray,
                          &$tagarray,
                          &$acquiredarray,
                          &$searchstring,
                          &$processarray,
                          &$filenamearray,
                          &$limit));

   if(is_object($ret)) {
      return $ret;
   }

   $ret = prunebackdoor($selarray);

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "SELECT `log_id` AS `log`, ";
   $sql .=        "`backdoor`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "DATE_FORMAT(`acquired`, '%Y%m%dT%T') AS `acquired`, ";
   $sql .=        "DATE_FORMAT(`received`, '%Y%m%dT%T') AS `received`, ";
   $sql .=        "`varchar1` AS `process`, ";
   $sql .=        "`varchar2` AS `filename`, ";
   $sql .=        "`int1` AS `sizehigh`, ";
   $sql .=        "`int2` AS `sizelow`, ";
   $sql .=        "`int3` AS `flags`, ";
   $sql .=        "`tag` AS `priority`, ";
   $sql .=        "COUNT(`note_id`) AS `notecount` ";
   $sql .= "FROM `log` ";
   $sql .= "LEFT JOIN `backdoor` USING (`backdoor_id`) ";
   $sql .= "LEFT JOIN `note` USING (`log_id`) ";
   $sql .= "WHERE (`backdoor` IN ('".implode("', '", $selarray)."')) AND ";
   $sql .=       "(`log_id` <= '".$_SESSION['authmaxlog']."') AND ";
   $sql .=       "(`type` = 'FILEOPEN') ";
   foreach(array('backdoorarray', 'remoteiparray', 'remotehostarray', 'remoteuserarray', 'tagarray') as $field) {
      $sql .= (count($$field) ? "AND (`".str_replace('array', '', $field)."` IN ('".implode("', '", $$field)."')) " : '');
   }
   if(count($acquiredarray)) {
      $sql .= "AND (0";
      foreach($acquiredarray as $acquired) {
         $sql .= " OR (`acquired` BETWEEN '".str_replace(':', '', $acquired['begin']->scalar)."' AND '".str_replace(':', '', $acquired['end']->scalar)."')";
      }
      $sql .= ") ";
   }
   if($searchstring) {
      $sql .= "AND (0";
      foreach(array('varchar1', 'varchar2') as $field) {
         $sql .= " OR (`$field` REGEXP '$searchstring')";
      }
      $sql .= ") ";
   }
   $sql .= (count($processarray) ? "AND (`varchar1` IN ('".implode("', '", $processarray)."')) " : '');
   $sql .= (count($filenamearray) ? "AND (`varchar2` IN ('".implode("', '", $filenamearray)."')) " : '');
   $sql .= "GROUP BY `log_id`";
   if($limit >= 0) {
      $sql .= " ORDER BY `log_id` DESC";
      $sql .= " LIMIT $limit";
   }

   $ret = db_query($sql);

   if(is_object($ret)) {
      return $ret;
   } else if($ret === false) {
      return $GLOBALS['err_log']['empty'];
   }

   foreach($ret as &$r) {
      settype($r->log, 'integer');
      xmlrpc_set_type($r->acquired, 'datetime');
      xmlrpc_set_type($r->received, 'datetime');
      settype($r->sizehigh, 'integer');
      settype($r->sizelow, 'integer');
      settype($r->flags, 'integer');
      settype($r->priority, 'integer');
      settype($r->notecount, 'integer');
   }
   unset($r);

   return $ret;
}

function log_fileopen_setgrouppriority($selarray, $linearray, $priority)
{
   $ret = db_escape(array(&$selarray,
                          &$linearray,
                          &$priority));

   if(is_object($ret)) {
      return $ret;
   }

   $ret = prunebackdoor($selarray);

   if(is_object($ret)) {
      return $ret;
   }

   $sql  = "REPLACE INTO `log` (`log_id`, ";
   $sql .=                     "`tag`, ";
   $sql .=                     "`type`, ";
   $sql .=                     "`backdoor_id`, ";
   $sql .=                     "`remoteip`, ";
   $sql .=                     "`remotehost`, ";
   $sql .=                     "`remoteuser`, ";
   $sql .=                     "`received`, ";
   $sql .=                     "`acquired`, ";
   $sql .=                     "`varchar1`, ";
   $sql .=                     "`varchar2`, ";
   $sql .=                     "`varchar3`, ";
   $sql .=                     "`int1`, ";
   $sql .=                     "`int2`, ";
   $sql .=                     "`int3`, ";
   $sql .=                     "`longtext1`, ";
   $sql .=                     "`longblob1`) ";
   $sql .= "SELECT `log_id`, ";
   $sql .=        "$priority, ";
   $sql .=        "`type`, ";
   $sql .=        "`backdoor_id`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "`received`, ";
   $sql .=        "`acquired`, ";
   $sql .=        "`varchar1`, ";
   $sql .=        "`varchar2`, ";
   $sql .=        "`varchar3`, ";
   $sql .=        "`int1`, ";
   $sql .=        "`int2`, ";
   $sql .=        "`int3`, ";
   $sql .=        "`longtext1`, ";
   $sql .=        "`longblob1` ";
   $sql .= "FROM `log` ";
   $sql .= "LEFT JOIN `backdoor` USING (`backdoor_id`) ";
   $sql .= "WHERE (`backdoor` IN ('".implode("', '", $selarray)."')) AND ";
   $sql .=       "(`type` = 'FILEOPEN') AND ";
   if(count($linearray)) {
      $sql .= "(0";
      foreach($linearray as $line) {
         $sql .= " OR (1";
         foreach(array('backdoor', 'remoteip', 'remotehost', 'remoteuser') as $field) {
            $sql .= (isset($line[$field]) ? " AND (`$field` = '".$line[$field]."')" : '');
         }
         $sql .= (isset($line['priority']) ? " AND (`tag` = '".$line['priority']."')" : '');
         if(isset($line['search']) && $line['search']) {
            $sql .= " AND (0";
            foreach(array('varchar1', 'varchar2') as $field) {
               $sql .= " OR (`$field` REGEXP '".$line['search']."')";
            }
            $sql .= ")";
         }
         if(isset($line['begin']) && isset($line['end'])) {
            $sql .= " AND (`acquired` BETWEEN '".str_replace(':', '', $line['begin']->scalar)."' AND '".str_replace(':', '', $line['end']->scalar)."')";
         }
         $sql .= (isset($line['process']) ? " AND (`varchar1` = '".$line['process']."')" : '');
         $sql .= (isset($line['filename']) ? " AND (`varchar2` = '".$line['filename']."')" : '');
         $sql .= ")";
      }
      $sql .= ") AND ";
   }
   $sql .=       "(`log_id` <= '".$_SESSION['authmaxlog']."')";

   $ret = db_query($sql);

   return $ret;
}

?>
